﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

using MindFusion.Diagramming;

namespace TableNodes
{
	public partial class MainPage : ContentPage
	{
		public MainPage()
		{
			InitializeComponent();

			diagram = diagramView.Diagram;
			diagram.Behavior = MindFusion.Diagramming.Behavior.LinkTables;

			diagram.AllowSelfLoops = false;
			diagram.BackBrush = new MindFusion.Drawing.SolidBrush(Color.FromRgb(240, 240, 240));
			diagram.LinkHeadShape = MindFusion.Diagramming.Shape.FromId("Triangle");
			diagram.LinkHeadShapeSize = 4F;
			diagram.TableRowCount = 0;
			diagram.TablesScrollable = true;
			diagram.ShowContextMenu = true;

			diagram.TableNodeStyle.Brush = new MindFusion.Drawing.LinearGradientBrush(Color.FromRgb(224, 233, 233),
				Color.FromRgb(102, 154, 204), 30);
			diagram.TableNodeStyle.TextBrush = new MindFusion.Drawing.SolidBrush(Color.FromRgb(45, 57, 86));
			diagram.TableNodeStyle.CellTextBrush = new MindFusion.Drawing.SolidBrush(Color.FromRgb(45, 57, 86));
			diagram.TableNodeStyle.Stroke = new MindFusion.Drawing.SolidBrush(Color.FromRgb(192, 192, 192));
			diagram.DiagramLinkStyle.Stroke = new MindFusion.Drawing.SolidBrush(Color.FromRgb(192, 192, 192));
			diagram.DiagramLinkStyle.HeadStroke = new MindFusion.Drawing.SolidBrush(Color.FromRgb(192, 192, 192));
			diagram.DiagramLinkStyle.Brush = new MindFusion.Drawing.SolidBrush(Color.FromRgb(0, 52, 102));
			diagram.AllowInplaceEdit = true;
			diagram.CellClicked += Diagram_CellClicked;
			diagram.RadialMenuCreated += Diagram_RadialMenuCreated;



		}

		private void Diagram_CellClicked(object sender, CellEventArgs e)
		{
			diagram.BeginEdit(e.Table, e.Cell, e.Position);
		}

		private void Diagram_RadialMenuCreated(object sender, RadialMenuEventArgs e)
		{
			e.Menu.ClearItems();

			var item = e.Menu.AddMenuItem("add_row.png");
			item.Clicked += Item_Clicked;

			item = e.Menu.AddMenuItem("delete_row.png");
			item.Clicked += Delete_Clicked;
		}

		private void Delete_Clicked(object sender, MenuItemEventArgs e)
		{
			TableNode node = e.Item as TableNode;
			int row = -1;
			int column = -1;

			if(node.CellFromPoint(new Point(e.X, e.Y), ref row, ref column))
			{
				node.DeleteRow(row);
			}
		}

		private void Item_Clicked(object sender, MenuItemEventArgs e)
		{
			TableNode node = e.Item as TableNode;
			node.AddRow();
		}

		Diagram diagram;
	}
}
